# A simple analytical method for estimation of the five parameter model: second-order with zero plus time-delay

MATLAB's implementation of A simple analytical method for estimation of the five parameter model: second-order with zero plus time-delay.

DOI: [10.5281/zenodo.4761376](https://doi.org/10.5281/zenodo.4761376)

The algorithms are presented in the manuscript submitted to the MDPI Mathematics.

### Authors:

[Tomaž Kos](https://www.researchgate.net/profile/Tomaz_Kos2) and [Damir Vrančić](https://www.researchgate.net/profile/Damir_Vrancic2), Department of Systems and Control, Jozef Stefan Institute (JSI), Jamova cesta 39, 1000 Ljubljana, Slovenia

## Installation

Implemented code was tested in MATLAB version 2018. No additional installation is needed. Just run one of the main scripts (`*.m` files in the root directory of the code).

## Description of the main MATLAB scripts used in paper

- `Algorithm.m`

This .m file obtains equations for second-order (five-parameter) process model identification from the characteristics areas (process models). Used in Section 3 of the paper.

- `Test_frequency_domain.m`

This .m file tests proposed model identification method in the frequency-domain (identification of the model from a general-order transfer function with a time-delay). Used in Section 4.1 of the paper.

- `Test_time_domain.m`

This .m file tests proposed model identification method in the time-domain (identification from an open-loop time response of a process). Used in Section 4.2 of the paper.

- `Test_time_domain_noise.m`

This .m file tests proposed model identification method in the time-domain under process noise. Used in Section 4.2 of the paper.
