%% This file plots the time responses for noise time-domain analysis ------

y_size_nr = 5;
plot_lines_max = 1000;

addpath('func_ExportFigure');
addpath('func_plot');
if ~exist(fullfile(pwd, image_dir), 'dir')
    mkdir(fullfile(pwd, image_dir));
end
img_name = strcat(char(image_name),'_',char(method),'_','SimResp');

plot_len = iter;

legend_text_size = 9;
line_width = 0.5;

N_lin_style = "'-'";
N_line_color = "'c'";
M_line_sytle = "'--'";
M_line_color = "'r'";

[P_subplot,P_fig] = subplot_position(240,173,2,2,0,35,15,0,0,10,25);
figure('Name',char(strcat('Process',{' '},display,{' '},'response on reference change and input disturbance')),'NumberTitle','off','Position',P_fig);

subplot('position',P_subplot{1});
hold on;
    vector_temp = data_ref(1:10:end,[1:y_size_nr]);
    p1 = plot(vector_temp(:,1),vector_temp(:,2),'LineStyle',eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    for i=2:plot_len
        vector_temp = data_ref(1:10:end,[((i-1)*y_size_nr+1):(i*y_size_nr)]);
        plot(vector_temp(:,1),vector_temp(:,2),'LineStyle',eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    end
    vector_temp = data_ref(1:10:end,[(plot_len*y_size_nr+1):((plot_len+1)*y_size_nr)]);
    p2 = plot(vector_temp(:,1),vector_temp(:,2),'LineStyle',eval(M_line_sytle),'Color',eval(M_line_color),'linewidth',line_width*1.5);
    vector_temp = data_ref(:,[1:y_size_nr]);
    p3 = plot(vector_temp(:,1),vector_temp(:,4),'k','DisplayName','reference','linewidth',0.5);
grid;
ah = gca;
set(ah,'box','off','color','none');
bh = axes('Position',get(ah,'Position'),'box','on','xtick',[],'ytick',[]);
axes(ah);
linkaxes([ah bh]);
[y_min, y_max] = process_y_min_max(data_ref,plot_len+1,y_size_nr);
ylim([y_min, y_max]);
xlim([0 Tsim_ref_stop]);
set(gca,'XMinorTick','on','YMinorTick','on');
leg = legend([p1(1),p2(1),p3(1)],char(legend_s(1)),char(legend_s(2)),'reference','fontsize',legend_text_size);
leg.Position(3) = 0;
leg.Position(4) = 0;
set(leg,'location','Best');
ylabel(char(strcat('Process output [/]')));
title('Reference tracking response', 'FontWeight','Normal');
set(gca,'xticklabel',[]);

subplot('position',P_subplot{3});
hold on;
    vector_temp = data_ref(1:10:end,[1:y_size_nr]);
    p1 = plot(vector_temp(:,1),vector_temp(:,3),'LineStyle',eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    for i=2:plot_len
        vector_temp = data_ref(1:10:end,[((i-1)*y_size_nr+1):(i*y_size_nr)]);
        plot(vector_temp(:,1),vector_temp(:,3),'LineStyle',eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    end
    vector_temp = data_ref(1:10:end,[(plot_len*y_size_nr+1):((plot_len+1)*y_size_nr)]);
    p2 = plot(vector_temp(:,1),vector_temp(:,3),'LineStyle',eval(M_line_sytle),'Color',eval(M_line_color),'linewidth',line_width*1.5);
    vector_temp = data_ref(:,[1:y_size_nr]);
    p3 = plot(vector_temp(:,1),vector_temp(:,5),'k','DisplayName','disturbance','linewidth',0.5);
grid;
ah = gca;
set(ah,'box','off','color','none');
bh = axes('Position',get(ah,'Position'),'box','on','xtick',[],'ytick',[]);
axes(ah);
linkaxes([ah bh]);
[y_min, y_max] = controller_y_min_max(data_ref(1:10:end,:),plot_len+1,y_size_nr,10);
ylim([y_min, y_max]);
xlim([0 Tsim_ref_stop]);
set(gca,'XMinorTick','on','YMinorTick','on');
ylabel(char(strcat('Controller output [/]')));
xlabel('time [s]');

subplot('position',P_subplot{2})
hold on;
    vector_temp = data_dist(1:10:end,[1:y_size_nr]);
    p1 = plot(vector_temp(:,1),vector_temp(:,2),'LineStyle',eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    for i=2:plot_len
        vector_temp = data_dist(1:10:end,[((i-1)*y_size_nr+1):(i*y_size_nr)]);
        plot(vector_temp(:,1),vector_temp(:,2),'LineStyle',eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    end
    vector_temp = data_dist(1:10:end,[(plot_len*y_size_nr+1):((plot_len+1)*y_size_nr)]);
    p2 = plot(vector_temp(:,1),vector_temp(:,2),'LineStyle',eval(M_line_sytle),'Color',eval(M_line_color),'linewidth',line_width*1.5);
    vector_temp = data_dist(:,[1:y_size_nr]);
    p3 = plot(vector_temp(:,1),vector_temp(:,4),'k','DisplayName','reference','linewidth',0.5);
grid;
ah = gca;
set(ah,'box','off','color','none');
bh = axes('Position',get(ah,'Position'),'box','on','xtick',[],'ytick',[]);
axes(ah);
linkaxes([ah bh]);
[y_min, y_max] = process_y_min_max(data_dist,plot_len+1,y_size_nr);
ylim([y_min, y_max]);
xlim([0 Tsim_dist_stop]);
set(gca,'XMinorTick','on','YMinorTick','on');
title('Disturbance rejection response', 'FontWeight','Normal');
set(gca,'xticklabel',[]);

subplot('position',P_subplot{4})
hold on;
    vector_temp = data_dist(1:10:end,[1:y_size_nr]);
    p1 = plot(vector_temp(:,1),vector_temp(:,3),'LineStyle',eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    for i=2:plot_len
        vector_temp = data_dist(1:10:end,[((i-1)*y_size_nr+1):(i*y_size_nr)]);
        plot(vector_temp(:,1),vector_temp(:,3),'LineStyle',eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    end
    vector_temp = data_dist(1:10:end,[(plot_len*y_size_nr+1):((plot_len+1)*y_size_nr)]);
    p2 = plot(vector_temp(:,1),vector_temp(:,3),'LineStyle',eval(M_line_sytle),'Color',eval(M_line_color),'linewidth',line_width*1.5);
    vector_temp = data_dist(:,[1:y_size_nr]);
    p3 = plot(vector_temp(:,1),vector_temp(:,5),'k','DisplayName','disturbance','linewidth',0.5);
grid;
ah = gca;
set(ah,'box','off','color','none');
bh = axes('Position',get(ah,'Position'),'box','on','xtick',[],'ytick',[]);
axes(ah);
linkaxes([ah bh]);
[y_min, y_max] = controller_y_min_max(data_dist,plot_len,y_size_nr,10);
ylim([y_min, max(vector_temp(:,5))*1.05]);
xlim([0 Tsim_dist_stop]);
set(gca,'XMinorTick','on','YMinorTick','on');
xlabel('time [s]');
leg = legend([p1(1),p2(1),p3(1)],char(legend_s(1)),char(legend_s(2)),'disturbance','fontsize',legend_text_size);
leg.Position(3) = 0;
leg.Position(4) = 0;
set(leg,'location','NorthEast');

% Crop white area around image
tightfigadv();
clearvars ans

% Save image
export_figure_as_vecgra([], fullfile(pwd, image_dir, img_name), '-dmeta');
export_figure_as_vecgra([], fullfile(pwd, image_dir, img_name), '-dpdf');

clearvars unit y_size_nr plot_lines_max lin_style lin_width plot_names vector_s plot_num ii array_min array_max plot_data_ref plot_data_dist unit
clearvars plot_len P_subplot P_fig vector_temp ah bh y_min y_max leg i plot_ref plot_dist plot_names img_save_name img_name legend_text_size

%% Functions --------------------------------------------------------------
% Function finds min and max yaxis limits for process output
function [min_nr, max_nr] = process_y_min_max(input,plot_len,y_size_nr)
    vect_min = [];
    vect_max = [];

    for iz=0:plot_len-1
        vector_temp = input(:,[(iz*y_size_nr+1):((iz+1)*y_size_nr)]);
        vect_min = [vect_min;min(vector_temp(:,2))];
        vect_max = [vect_max;max(vector_temp(:,2))];
    end

    if min(vect_min)<0
        min_nr = min(vect_min)*1.2;
    else
        min_nr = min(vect_min)*0.9;
    end
    
    max_nr = max(vect_max)*1.1;   
end

% Function finds min and max yaxis limits for controller output
function [min_nr, max_nr] = controller_y_min_max(input,plot_len,y_size_nr,max_min_limit)
    vect_min = [];
    vect_max = [];

    for iz=0:plot_len-1
        vector_temp = input(:,[(iz*y_size_nr+1):((iz+1)*y_size_nr)]);
        vect_min = [vect_min;min(vector_temp(:,3))];
        vect_max = [vect_max;max(vector_temp(:,3))];
    end

    if min(vect_min)<0
        min_nr = min(vect_min)*1.1;
    else
        min_nr = min(vect_min)*0.9;
    end
    
    max_nr = max(vect_max)*1.1;
    if max_nr > abs(min_nr)*max_min_limit && max_min_limit~=0
        if min_nr==0
            max_nr = max_min_limit;
        else
            max_nr = abs(min_nr)*max_min_limit;
        end
    end    
end