%% This file performs simulations and saves data into arrays --------------

% set temp files into separate folder
Simulink.fileGenControl('set','CacheFolder', fullfile(pwd, '_temp_'),'CodeGenFolder', fullfile(pwd, '_temp_'),'createDir', true);

addpath('Controllers');

sim_file = 'P_PID.slx';

if 1~=exist('plot_compare','var')
    plot_compare = 'no';
end

%reference
Ts_y = Tsim_ref_stop/1000;
Tstop = Tsim_ref_stop;
Tstep1 = Tsim_ref_stop/20;
Tstep2 = Tstop+1;
sim (sim_file);
y_ref = y;


%disturbance
Ts_y = Tsim_dist_stop/1000;
Tstop = Tsim_dist_stop;
Tstep1 = Tstop+1;
Tstep2 = Tsim_dist_stop/20;
sim (sim_file);
y_dist = y;

Simulink.fileGenControl('reset');
clearvars Tstop Tstep1 Tstep2 sim_file y Criteria tmp

% Put simulation data in table
data_ref = [data_ref y_ref];
data_dist = [data_dist y_dist];
method_compar = [method_compar; plot_compare];
clearvars plot_compare y_ref y_dist

% Calculate and put in table
table_rows = [table_rows; method];

% String of tuning method parameters
s = char(strcat(method,{' '},display,{' parameters '},param_text,{':'}));
disp(s);
s = char(strcat({'     '}, num2str(param)));
disp(s);
clearvars s