% Plot Nyquist plots of models --------------------------------------------
nr_plots = size(y_data); nr_plots = nr_plots(2);
w = logspace(w_start,w_start+(dec_nr-1),(dec_nr-1)*1e4);

[P_subplot,P_fig,P_colorbar] = subplot_position(400,400,1,1,2,5,5,25,12,50,50);
figure('Name',char(strcat('Process',{' '},display,{' '},'Nyquist plot')),'NumberTitle','off','Position',P_fig);
subplot('position',P_subplot{1});
for i=1:nr_plots
    [re,im,w] = nyquist(Ptf_data(i),w); 
    re = squeeze(re); im = squeeze(im);
    [line_width,line_style] = get_line_width_style(i,method_compar(i));
    plot(re,im,eval(line_style),'linewidth',eval(line_width),'DisplayName',char(method_name(i)));
    hold on;
end
grid;
set(gca,'XMinorTick','on','YMinorTick','on');
%axis([-1 1 -1 1]);
ylabel('Imaginary');
xlabel('Real');
leg = legend();
set(leg,'location','Best');
tightfigadv();

if ~exist(fullfile(pwd, image_dir), 'dir')
    mkdir(fullfile(pwd, image_dir));
end

img_name = strcat(char(image_name),'_',char(display),'_Nyquist');
export_figure_as_vecgra([], fullfile(pwd, image_dir, img_name), '-dmeta');
export_figure_as_vecgra([], fullfile(pwd, image_dir, img_name), '-dpdf');