% Plot Nyquist plots of models under noise --------------------------------

N_lin_style = "'-'";
N_line_color = "'c'";
M_line_sytle = "'--'";
M_line_color = "'r'";
line_width = 0.5;
legend_text_size = 9;

nr_plots = length(Ptf_data);
w_plot = logspace(w_start,w_start+(dec_nr-1),(dec_nr-1)*5e1);

[P_subplot,P_fig,P_colorbar] = subplot_position(400,400,1,1,2,5,5,25,12,50,50);
figure('Name',char(strcat('Process',{' '},display,{' '},'Nyquist plot')),'NumberTitle','off','Position',P_fig);
subplot('position',P_subplot{1});
for i=1:1:nr_plots-1
    [re,im,~] = nyquist(Ptf_data(i),w_plot);
    re = squeeze(re); im = squeeze(im);
    p1 = plot(re,im,eval(N_lin_style),'Color',eval(N_line_color),'linewidth',line_width);
    hold on;
end
[re,im,~] = nyquist(Ptf_data(nr_plots),w_plot);
re = squeeze(re); im = squeeze(im);
p2 = plot(re,im,eval(M_line_sytle),'Color',eval(M_line_color),'linewidth',line_width*1.5);

grid;
set(gca,'XMinorTick','on','YMinorTick','on');
xlim auto;
ylim auto;
ylabel('Imaginary');
xlabel('Real');

leg = legend([p1(1),p2(1)],char(method),'Process','fontsize',legend_text_size);
leg.Position(3) = 0;
leg.Position(4) = 0;
set(leg,'location','Best');

tightfigadv();

if ~exist(fullfile(pwd, image_dir), 'dir')
    mkdir(fullfile(pwd, image_dir));
end

img_name = strcat(char(image_name),'_',char(display),'_Nyquist_',num2str(n));
export_figure_as_vecgra([], fullfile(pwd, image_dir, img_name), '-dmeta');
export_figure_as_vecgra([], fullfile(pwd, image_dir, img_name), '-dpdf');