% Plot time responses -----------------------------------------------------
nr_plots = size(y_data); nr_plots = nr_plots(2);

[P_subplot,P_fig,P_colorbar] = subplot_position(460,300,1,1,2,5,5,25,12,50,50);
figure('Name',char(strcat('Process',{' '},display,{' '},'identification test')),'NumberTitle','off','Position',P_fig);
subplot('position',P_subplot{1});
for i=1:nr_plots
    [line_width,line_style] = get_line_width_style(i,method_compar(i));
    plot(t_plot,y_data(:,i),eval(line_style),'linewidth',eval(line_width),'DisplayName',char(method_name(i)));
    hold on;
end
plot(t_plot,u_plot,'k','linewidth',0.5,'DisplayName','Process input');
grid;
ah = gca;
set(ah,'box','off','color','none');
bh = axes('Position',get(ah,'Position'),'box','on','xtick',[],'ytick',[]);
axes(ah);
linkaxes([ah bh]);
[min_nr,max_nr] = process_y_min_max(y_data);
ylim([min_nr max_nr]);
xlim([0 t_plot(end)]);
set(gca,'XMinorTick','on','YMinorTick','on');
ylabel('Process output [/]');
xlabel('time [s]');
leg = legend();
set(leg,'location','Best');
tightfigadv();

if ~exist(fullfile(pwd, image_dir), 'dir')
    mkdir(fullfile(pwd, image_dir));
end

img_name = strcat(char(image_name),'_',char(display),'_OL');
export_figure_as_vecgra([], fullfile(pwd, image_dir, img_name), '-dmeta');
export_figure_as_vecgra([], fullfile(pwd, image_dir, img_name), '-dpdf');

function [min_nr,max_nr] = process_y_min_max(y_data)

min_nr = min(min(y_data));
max_nr = max(max(y_data));

if min_nr<0
    min_nr = min_nr*1.1;
else
    min_nr = min_nr*0.98;
end
max_nr = max_nr*1.02;

end