% simulate model ----------------------------------------------------------
P_tf = tf(num,den,'InputDelay',Tdelay);
[y_model] = lsim(P_tf,u,t);

% simulate Criteria -------------------------------------------------------
% calculate IAE
err = y_process-y_model;
IAE = ( sum(abs(err))*Ts )/abs( max(y_process)-min(y_process) );

% calculate ERR
[re,im] = nyquist(P_tf,w_err);
re = squeeze(re);
im = squeeze(im);
Euc_dist = sqrt( (re-P_nyq_data(:,1)).^2 + (im-P_nyq_data(:,2)).^2 );
ERR = mean(Euc_dist);

% save data ---------------------------------------------------------------
method_name = [method_name; method];

y = y_model(1:int32((end/T_factor)+0.5), :);
y_data = [y_data y];
clearvars y;

Ptf_data = [Ptf_data; P_tf];

criteria_data = [criteria_data; [IAE ERR] ];

if 1~=exist('plot_compare','var')
    plot_compare = 'no';
end
method_compar = [method_compar; plot_compare];
clearvars plot_compare err IAE re im Euc_dist ERR