% Create variables for plot and print -------------------------------------
method_name = {};
y_data = [];
criteria_data = [];
Ptf_data = [];
method_compar = {};

if 1<length(num) & 0>num(1)
    process_type = "non-minimum phase";
else
    process_type = "minimum phase";
end

% Areas in the frequeny domain --------------------------------------------
[A0_fd,A1_fd,A2_fd,A3_fd,A4_fd,A5_fd] = numden2areas (num,den,Tdelay);
s = char(strcat('Areas of the process in the f. dom. [A0 A1 A2 A3 A4]',...
    {newline},{'     '},num2str([A0_fd A1_fd A2_fd A3_fd A4_fd])));
disp(s);

% time variables ----------------------------------------------------------
T_factor = 3;
t_max = t_stop*T_factor;
t = [0:Ts:t_max]';
t_step = t_stop/20;
u = ones(size(t)); u(1:t_step*(1/Ts)) = zeros(size(u(1:t_step*(1/Ts))));

% Process -----------------------------------------------------------------
P_tf = tf(num,den,'InputDelay',Tdelay);
[y_process] = lsim(P_tf,u,t);

% Areas in the time domain ------------------------------------------------
Tf = 0.01;
F_tf = tf([1],[Tf 1]);
[u_f] = lsim(F_tf,u,t);
[y_f] = lsim(F_tf,y_process,t); % Filtering signals (numerical error)
[A0,A1,A2,A3,A4,A5] = meas2areas (y_f,u_f,t,0,t_max);
s = char(strcat('Areas of the process in the t. dom. [A0 A1 A2 A3 A4]',...
    {newline},{'     '},num2str([A0 A1 A2 A3 A4])));
disp(s);
clearvars Tf F_tf u_f y_f

% Frequency domain criteria -----------------------------------------------
w_start = log10(A0_fd/A1_fd * 1/100);
dec_nr = 5;
w = logspace(w_start,w_start+dec_nr,dec_nr*1e5);
[mag_P,phase_P] = bode(P_tf,w);
mag_P = squeeze(mag_P);
phase_P = squeeze(phase_P);

%Get phase origin
[~,corrPhase,~] = bode(P_tf,0);
phase_P = phase_P-corrPhase;

mag_P_lim = mag_P(1)/200; % First condition (amplitude)
phase_P_lim = -180; % Second condition (phase)
cond1 = find(mag_P<=mag_P_lim);
cond2 = find(phase_P<=phase_P_lim);
if (cond1(1)<cond2(1))
    tmp = cond1(1);
    condition = 'amplitude';
else
    tmp = cond2(1);
    condition = 'phase';
end
w_err = w(1:tmp);
[re,im] = nyquist(P_tf,w_err);
re = squeeze(re);
im = squeeze(im);
P_nyq_data = [re im];
s = char(strcat('w0 [rad/s]:',...
    {newline},{'     '},num2str(w_err(1)),{''}));
disp(s);
s = char(strcat('wc of the criterion simulation [rad/s]:',...
    {newline},{'     '},num2str(w_err(end)),{''},strcat('(',condition,' condition)')));
disp(s);
clearvars w mag_P phase_P corrPhase mag_P_lim cond1 cond2 condition tmp re im

% Prepare data ------------------------------------------------------------
t_plot = t(1:int32((end/T_factor)+0.5), :);
u_plot = u(1:int32((end/T_factor)+0.5), :);

% Save data ---------------------------------------------------------------
method_name = [method_name; "Process"];

y = y_process(1:int32((end/T_factor)+0.5), :);
y_data = [y_data y];
clearvars y;

Ptf_data = [Ptf_data; P_tf];

criteria_headers={'IAE','ERR'};
criteria_data = [criteria_data; [NaN NaN]];

method_compar = [method_compar; 'no'];