% Create variables for plot and print -------------------------------------
method_name = {};
y_data = [];
criteria_data = [];
Ptf_data = [];
method_compar = {};

if 1<length(num) & 0>num(1)
    process_type = "non-minimum phase";
else
    process_type = "minimum phase";
end

% Areas in the frequeny domain --------------------------------------------
[A0_fd,A1_fd,A2_fd,A3_fd,A4_fd,A5_fd] = numden2areas (num,den,Tdelay);
s = char(strcat('Areas of the process in the f. dom. [A0 A1 A2 A3 A4]',...
    {newline},{'     '},num2str([A0_fd A1_fd A2_fd A3_fd A4_fd])));
disp(s);

% time variables ----------------------------------------------------------
T_factor = 2;
t_max = t_stop*T_factor;
t = [0:Ts:t_max]';
u = ones(size(t)); u(1:t_step*(1/Ts)) = zeros(size(u(1:t_step*(1/Ts))));

% Process -----------------------------------------------------------------
P_tf = tf(num,den,'InputDelay',Tdelay);
[y_process] = lsim(P_tf,u,t);

% Areas in the time domain ------------------------------------------------
[u_f] = lsim(F_tf,u,t); % Filtering signal
[y_f] = lsim(F_tf,y_process,t); % Filtering signal
[A0,A1,A2,A3,A4,A5] = meas2areas_2(y_f,u_f,t,t_start, t_integ, t_avg,t_stop);
s = char(strcat('Areas of the process in the t. dom. (without noise) [A0 A1 A2 A3 A4]',...
    {newline},{'     '},num2str([A0 A1 A2 A3 A4])));
disp(s);
clearvars y_f

% Estimated model (without noise) -----------------------------------------
[Kpr_f,a1_f,a2_f,b1_f,Tdm_f,error] = area2Model_2DZ_Tdm(A0_fd,A1_fd,A2_fd,A3_fd,A4_fd,process_type);
s = char(strcat('Estimated model parameters in the f. dom. [Kpr a1 a2 b1 Tdm]',...
    {newline},{'     '},num2str([Kpr_f a1_f a2_f b1_f Tdm_f])));
disp(s);

[Kpr_t,a1_t,a2_t,b1_t,Tdm_t,error] = area2Model_2DZ_Tdm(A0,A1,A2,A3,A4,process_type);
s = char(strcat('Estimated model parameters in the t. dom. (without noise) [Kpr a1 a2 b1 Tdm]',...
    {newline},{'     '},num2str([Kpr_t a1_t a2_t b1_t Tdm_t])));
disp(s);

% Frequency domain criteria -----------------------------------------------
w_start = log10(A0_fd/A1_fd * 1/100);
dec_nr = 5;
w = logspace(w_start,w_start+dec_nr,dec_nr*1e5);
[mag_P,phase_P] = bode(P_tf,w);
mag_P = squeeze(mag_P);
phase_P = squeeze(phase_P);

%Get phase origin
[~,corrPhase,~] = bode(P_tf,0);
phase_P = phase_P-corrPhase;

mag_P_lim = mag_P(1)/200; % First condition (amplitude)
phase_P_lim = -180; % Second condition (phase)
cond1 = find(mag_P<=mag_P_lim);
cond2 = find(phase_P<=phase_P_lim);
if (cond1(1)<cond2(1))
    tmp = cond1(1);
    condition = 'amplitude';
else
    tmp = cond2(1);
    condition = 'phase';
end
w_err = w(1:tmp);
[re,im] = nyquist(P_tf,w_err);
re = squeeze(re);
im = squeeze(im);
P_nyq_data = [re im];
s = char(strcat('w0 [rad/s]:',...
    {newline},{'     '},num2str(w_err(1)),{''}));
disp(s);
s = char(strcat('wc of the criterion simulation [rad/s]:',...
    {newline},{'     '},num2str(w_err(end)),{''},strcat('(',condition,' condition)')));
disp(s);
clearvars w mag_P phase_P corrPhase mag_P_lim cond1 cond2 condition tmp re im mag_P_lim phase_P_lim s

% Prepare plot names ------------------------------------------------------
plot_legend_arr = [];
for n=1:1:length(Noise_amp_arr)
    plot_legend_arr = [plot_legend_arr; {char(strcat(plot_legend_str, {' '}, num2str(Noise_amp_arr(n))))}];
end
clearvars n

% Prepare data ------------------------------------------------------------
t_plot = t(1:int32((end/T_factor)+0.5), :);
u_plot = u(1:int32((end/T_factor)+0.5), :);

% Save data ---------------------------------------------------------------
method_name = [method_name; "Without noise"];

y = y_process(1:int32((end/T_factor)+0.5), :);
y_data = [y_data y];
clearvars y;

Ptf_data = [Ptf_data; P_tf];
clearvars P_tf

method_compar = [method_compar; 'no'];